<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta name="MSSmartTagsPreventParsing" content="TRUE" />
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="keywords" content="virus,virii,activex, av, avp, cai, clamscan, content scanner, e-mail, email, enterprise, filtering, f-prot, fsecure, inoculan, internet, intranet, java, javascript, linux, macafee, commandcom, misuse anti-virus, network, perl, qmail, qmail-queue qmail-scanner, scan, scan, scan4virus, scanning, scanning, script, security, SMTP, sophie, avast, sophos, spam, spam assassin, spamassassin, trend, trophie, unix, virus, worms">
   <meta date="<?php echo   date ("l dS of F Y h:i:s A",filemtime($_SERVER["SCRIPT_FILENAME"])); ?>">
   <title>Qmail-Scanner - A Content Scanner for Qmail</title>
</head>
<body bgcolor="#FFFFFF">
   <font size="-3"><b>Last Updated:</b> <?php echo   date ("r",filemtime($_SERVER["SCRIPT_FILENAME"])). " GMT"; ?></font>

<div align="right"><A href="http://sourceforge.net"> <IMG src="http://sourceforge.net/sflogo.php?group_id=6116" width="88" height="31" border="0" alt="SourceForge Logo"></A></div>


<div align="left"><a href="http://qmail-scanner.sourceforge.net/" align="left">URL: http://qmail-scanner.sourceforge.net/</a></div>
<center>
<h1>
<a href="http://qmail-scanner.sourceforge.net/" align="center">Qmail-Scanner:
Content Scanner for Qmail</a></h1></center>

<P>

      <i><font size="2">Copyright 2009 Jason Haar. This software is distributed
under the terms of the GNU General Public License. See <a href="COPYING">COPYING</a> for additional information.</font>
    </i>



<P>

<h2>Description</h2> 

<p><b>Qmail-Scanner</b> is an add-on that enables a Qmail email server to scan  gatewayed
email for certain characteristics (i.e. a content scanner).  It is typically used for its
anti-virus and anti-spam protection functions, in which case it is used in
	conjunction with external scanners. It also enables a site (at a server/site level) to create "<em>Policy blocks</em>": i.e.
react to email that contains specific strings
in particular headers, or particular attachment filenames or types
(e.g. *.VBS attachments). 
</p>
      <p>Its archival features helps ISPs and corporations around the world with new or pending legislation, and regulatory requirements. It can archive all processed email into an archive maildir. This is ideal for backup purposes  for audit policy reasons. Unlike certain Windows-based server solutions, the mail envelope headers (the "rcpt to:" and "mail from:" headers) are kept intact - appended to the bottom of each message - confirming true sender and destination addresses. Archiving also supports filtering to a subset of addresses (e.g. only archive "support@domain.name" emails instead of all).  In addition, the extensive single-line summaries generated for each message by Qmail-Scanner may be enough for companies meet their obligations - instead of the more disk-intensive full archiving. As usual, contact a lawyer for proper definitions.</p>
<p>
 Qmail-Scanner is integrated into the
mail server at a lower level than some other Unix-based virus
scanners, resulting in more thorough coverage. It is capable of scanning
not only locally sent/received email, but also email that crosses the
server in a relay capacity. Qmail-Scanner also leverages the wealth of meta-information provided by Qmail (such as client IP address, and whether or not the client is allowed to relay).
</p>
<h2>
Features</h2>

<ul>
<li>
Supports almost all commercial (Unix) virus scanners as well as the ever-popular Open Source ClamAV scanner.</li>

<li>
Can call more than one virus scanner for each mail message</li>

<li>
Has its own <a href="perlscanner.php">internal scanner</a> that can be used for Policy enforcement, or to quarantine viruses that your AV currently cannot detect</li>

<li>
The internal scanner can also be used to quarantine email based on attachment types,
or email with certain email headers... Need to stop *.mp3 files or "<b>Subject:</b>
ILOVEYOU" email getting onto and off your LAN - can do! :-)</li>
	<li>The internal scanner can trigger a "greylist" action instead of a quarantine. This is designed for emergency situations where your current AV and static Policy blocks are not appropriate. e.g. a new ZIP-based virus comes out with random filenames. Your AV cannot detect it, and you can't globally block ZIP files without hurting valid users. A "greylist" action will cause Qmail-Scanner to exit with a SMTP temporary failure instead of delivering the message. Valid emails will simply be requeued and can flow through later once your AV can detect the virus, and you decide to remove the greylist policy.</li>
	<li>Internal engine scans for poorly formatted messages that are known to be used by trojans/virii to infect clients. As such, this is <em>independent of any virus scanner, and can successfully operate against future virii/trojans</em>. Such messages are quarantined immediately. Known to block such major virii as Klez and Aliz, and as a side effect, stops a fair amount of spam too! Format checks include:
	  <ul>
	    <li>broken MIME continuation headers</li>
	    <li>use of comments within standard headers (e.g. "Content-T(xxxxxx)ype:" is *identical* to "Content-Type:" according to the RFCs - but some virii use this as it circumvents some anti-virus scanners). Valid use of this is never seen in the wild - so it's blocked</li>
	    <li>repeated occurrences of MIME headers makes Q-S rename the latter ones to nullify them</li>
	    <li>MIME boundaries over 250 chars are blocked</li>
	    <li>differing definitions of a particular attachment filename causes it to be blocked </li>
	    <li>double-defining the same MIME boundary is blocked</li>
	    <li>certain MIME types containing windows executable extensions are specifically blocked (e.g. an "audio/wav" of filename "wav.exe" could only be a virus)</li>
	    <li>broken headers within a MIME attachment are blocked</li>
	    <li>windows executable attachments that aren't marked as being of MIME type "application/....." are blocked (e.g. renaming notepade.exe to notepade.gif and sending it as a GIF attachment would be quarantined, as Qmail-Scanner would realise it's an executable pretending to be something else).</li>
	    <li>attachment filenames over 256 chars are blocked</li>
	    <li><em>some</em> double-barreled filenames are blocked (e.g. file.gif.exe). It tries <em>not to block</em> common mistake variants</li>
	    <li>CLSID file extensions are blocked</li>
	    <li>Password-protected zip files can be blocked if you wish. This would stop any future viruses stuffed inside password-protected zip files from getting through, but of course would also stop any legitimate usage. Turned off by default, but perhaps useful to turn on during a new outbreak, and turned off again once an AV update occurs that can catch it.</li>
	  </ul>
</li>
	    <li>defaults to always running any AV you may have over messages first, then runs the internal scanner (Policy/perlscan) checks. This means if you block ".PIF" files due to them normally containing viruses, then any .PIF files that do contain a virus known to your AV system will be flagged as "viruses", and any that were missed (perhaps they were a Day-Zero virus) are then tagged as being  blocked by "policy". This differentiation is then used by the alerting system. It defaults to not notifying the sender that a virus has been found, but can still notify them when it was a "policy" block.</li>
	<li>Quarantines emails it finds to contravene the above sub-systems. Viruses are quarantined into a maildir named "viruses/", policy-blocks into "policy/" and (potentially) high-rated SPAM into "spam/"</li>
	<li>Email that is quarantined can be configured to trigger one of two different forms of notification:<BR>
	  <ol>
	    <li>defaults to generating a localizable (i.e. language support) email alert notifying the sender and/or recipient why their message was quarantined.</li>
	    <li>a SMTP reject error message (5XX) if desired. This is disabled by default. Needs the <a href=http://no-way.org/uploads/6/28/qmail-queue-custom-error.patch>Qmail Custom Error patch</a> if you want nicer SMTP error descriptions</li>
	    </ol></li>
      <li>Can integrate with SpamAssassin to provide comprehensive anti-spam tagging for an entire site. Typically uses also includes using Qmail-Scanner as a "front end" for Enterprise mail servers such as Notes and Exchange. Qmail-Scanner does all the dirty work - (hopefully) leaving nothing but clean mail for the backend :-)</li>
<li>
Auto-detects email from "postmaster"-style and mailing-list
addresses - and doesn't send virus alert reports to them (i.e. attempts to act
more like a responsible net citizen)</li>
	<li>Due to the fact that over 99.9% of all email-borne viruses are now sent using forged sender information, Q-S defaults to NOT alerting the sender that a message has been quarantined, unless it was due to a Policy/Perlscan block. This can be turned back to the "old" style by using "--notify sender" instead of the newer default of "--notify psender" (i.e. only notify sender for policy blocks)</li>
	<li>Knows of the virii which forge the From headers - so that the virus appears to come from some poor innocent. Qmail-Scanner will not send alerts to the sender for those types of virii. As the default is to not notify anyway, this only really takes effect if you are using the "--notify sender" option.</li>
<li>
Each message is tagged via a new <b>Received:</b> header
with a virus report showing whether it is clean or not and virus scanner
version numbers/etc</li>

	<li>[disabled by default] Messages classified as "serious SPAM" by the "--sa-quarantine" option (basically having a really high SA score) will be quarantined off into a "maildir" mail folder (./spam/). This separation into its own maildir allows sites to come up with their own methods of handling false positives. However...</li>
	<li>the "-z" cleanup option will delete messages in the quarantine subfolders older than 14 days</em> - to ensure it doesn't grow too large. If you want to keep them longer, simply script something to move them out daily to another directory/maildir. There is a <b>logrotate script in the contrib directory</b> to automate this (for those systems that can use it - like Redhat/CentOS)</li>

<li>
Can optionally add a descriptive header: <b>X-Qmail-Scanner</b>
to every email that passes through the system to allow users to see that
a scanner has run over their messages.</li>

<li>
Messages caught by Qmail-Scanner generate an email message (currently
	supports English, Italian, Afrikaans, Polish, Swedish, Czech, German, Spanish, Turkish,
	Lithuanian, French, Portuguese, Dutch and Chinese messages) to a configurable combination of the sender, recipients and a "quarantine-admin" address explaining why their message was blocked.
</Li>
<li>
	  Can archive some or all processed email (that wasn't quarantined) into an <b>archive</b> maildir.
Useful when debugging email-based apps, for backup purposes, and for audit
policy reasons. Currently the mail envelope headers (the "rcpt to:" and "mail from:" headers) are appended to the bottom of each message. This option supports being called with a regular expression in which case only envelope headers that match the expression are archived (e.g. can archive "(support|sales)@domain.name" instead of all email)</li>
<li>Reports via syslog or to a file, a one-line description of each processed message, giving extensive information such as subject line, attachment filenames, sizes, etc.</li>
<li>
Redundant scanning. Not only does it unpack each message
before running the scanners over it, it can also scan the original "raw" email
message as well as the unpacked components (i.e. if you think a particular scanner has better internal MIME parsing than <i>Qmail-scanner</i>)</li>
	<li>Reporting: in the contrib directory there's qs2mrtg.pl. A perl script for monitoring your syslog files for qmail-scanner records. It then graphs how Qmail-Scanner is processing your emails. It creates different graphs for incoming vs outgoing email, as well as the flow of spam and viruses.</li>
</ul>

<h2>
Download</h2>
The latest release is 2.08 <a href="http://prdownloads.sourceforge.net/qmail-scanner/qmail-scanner-2.08.tgz?download">(via http)</a>,
and is kindly housed by <a href="http://sourceforge.net/">SourceForge</a>. GnuPG signature of <a href="http://prdownloads.sourceforge.net/qmail-scanner/qmail-scanner-2.08.tgz.asc?download">qmail-scanner-2.08.tgz.asc</a> is also available. Of course, you'll be needing my <a href="http://qmail-scanner.sourceforge.net/jhaar@users.sourceforge.net.gpg">GPG Public Key</a> to verify that.
<h2>
Requirements</h2>

<ul>
<li>
Netqmail 1.05 (or qmail-1.03 with patches)</li>
	<li>Create a separate account under which to run Qmail-Scanner: defaults to username and groupname "<b>qscand</b>". For extra security, create it with a normal home directory (e.g. "/home/qscand"), but with a "fake" shell (e.g. "/bin/false") - as it's never logged into directly.</li>
<li>daemontools-0.76+</li>
<li>
<b>reformime</b> from <a href="http://www.courier-mta.org/maildrop/">Maildrop
1.3.8+</a></li>
 
<li>
	  Perl 5.005_03+ </li>

<li>
Perl module <a href="http://search.cpan.org/search?module=Time::HiRes">Time::HiRes</a></li>
<li>
Perl module <a href="http://search.cpan.org/search?module=DB_File">DB_File</a> (most distributions come with it pre-installed, although the latest Perl  doesn't)</li>
      <li>Perl module <a href="http://search.cpan.org/search?module=Sys::Syslog">Sys::Syslog</a> (most distributions come with it pre-installed)</li>
      <li>Perl module <a href="http://search.cpan.org/search?module=MIME::Base64">MIME::Base64</a> (most distributions come with it pre-installed)</li>
<li><b>Optional:</b> Mark Simpson's <a href="http://sourceforge.net/projects/tnef/">TNEF unpacker</a>. Can decode those annoying MS-TNEF MIME attachments that Microsoft mail servers just <em>love</em> to use. If you don't have this, there are several classes of email that Qmail-Scanner basically won't be able to extract attachments in. However, your AV might very well be able to handle them</li>
	<li><b>Optional:</b> uudecode (part of sharutils on Redhat-style systems)</li>
	<li><b>Optional:</b> unzip </li>
</ul>

<h3>
Patches</h3>

      <p>Qmail-Scanner relies on Bruce Guenter's <a href="http://www.qmail.org/qmailqueue-patch">QMAILQUEUE</a>
patch to enable qmail-1.03 to call a different qmail-queue program
than the one compiled in by default. If you are using <a href="http://www.qmail.org/netqmail/">netqmail-1.05</a>, then you already have the patch.</p>

<i>Qmail-scanner</i>'s
<b>qmail-scanner-queue.pl</b>
perl script is used instead of Qmail's
<b>qmail-queue</b> binary. After
<b>qmail-scanner-queue.pl</b>
has run, it calls the original <b>qmail-queue</b> binary to resubmit the
message back into the system.
<ul>
<li>
	  <b>Note 1:</b> Please see <a href="http://www.qmail.org/">www.qmail.org</a> for packaged distributions if you don't feel comfortable building Qmail itself from scratch. There are several RPM-styled src.rpms's available (e.g. <a href="http://www.qmailtoaster.com/">QmailToaster</a>, or <a href="http://www.qmailrocks.org/">QmailRocks</a>), along with all sorts of patches you may wish to have in your particular build. As mentioned above, please ensure you have Qmail working before installing Qmail-Scanner. On the Qmail-Scanner mailing-lists, we are seeing too many cases of users having "problems" - which end up being Qmail configuration/understanding issues... </li>
<li><b>Note 2:</b> All beginner Qmail Administrators should read <a href="http://www.lifewithqmail.org/">Life with Qmail</a> before even attempting to use Qmail</li>
</ul>

<h3>
Supported Virus Scanners</h3>
The following virus scanners are known to work with qmail-scanner. Remember that only the current releases of scanners are supported. There is little point in running an old scanner - you miss too many viruses.

<ul>

      <li><a href="http://www.clamav.net/">Clam Anti-Virus</a> - an Open Source anti-virus scanner</li>
      <li><a href="http://spamassassin.org/">Spam Assassin Daemon</a> (see <a href="FAQ.php">FAQ</a> for details)</li>
<li><a href="http://www.antivirus.com/">Trend's InterScan VirusWall Virus scanner</a></li>
<li>
<a href="http://www.avast.com/eng/download-avast-for-linux-server.html">AVAST! "avastlite/avastd" virus scanner</a></li>

<li>
<a href="http://www.sophos.com/">Sophos's "savscan" virus scanner</a></li>

<li>
<a href="http://www.hbedv.com/">H+BEDV's antivir scanner</a></li>

<li>
<a href="http://www.kaspersky.com/">Kaspersky's AVPLinux scanner</a></li>

<li>
<a href="http://www.nai.com/">MacAfee's (NAI's) virus scanner</a></li>
      <li><a href="http://www.commandsoftware.com">Command's virus scanner</a></li>
<li>
<a href="http://f-secure.com/">F-Secure Anti-Virus scanner</a></li>
      <li><a href="http://www.f-prot.com/products/corporate_users/unix/linux/fileserver.html">F-Prot Anti-Virus scanner</a></li>
<li>
<a href="http://www.cai.com/">InocuLAN Anti-Virus scanner</a></li>
      <!--li><a href="http://www.rav.ro/">RAV Anti-Virus</a></li-->
	<li><a href="http://www.bitdefender.com/bd/site/products.php?p_id=16">BitDefender Linux Edition</a></li>
	<li><a href="http://www.centralcommand.com/">Central Command's Vexira anti-virus scanner</a></li>
	<li><a href="http://www.nod32.com/">ESET NOD32 Anti-Virus scanner</a></li>

<li><a href="http://www.clanfield.info/sophie/">Sophie: Daemon front-end to Sophos Sweep</a> (see <a href="FAQ.php">FAQ</a> for details)</li>
<li><a href="http://www.vanja.com/tools/">Trophie: Daemon front-end to Trend iscan</a> (see <a href="FAQ.php">FAQ</a> for details)</li>
	<li><a href="http://www.grisoft.com/">AVG Anti-Virus</a></li>
</ul>

<p>Other Unix-based scanners should be simple to add support for.</p>

<h2>CHANGES</h2>
<P> There is a separate <a href="CHANGES">page</a> listing changes that have been made between releases </p>

<h2>
TODO</h2>
<p>       There is a separate <a href="TODO.php">TODO</a> page.</p>

<h2>
FAQ</h2>
<p>       There is a separate <a href="FAQ.php">FAQ</a> page.</p>

<h2>
Performance/Resource Usage</h2>

Adding content/virus scanning to an email server <i>will</i>
considerably add to the resource usage of that server. As this
"wrapper" is written in perl instead of low-level C, quite a lot of
memory and file opens/stats occurs just to get it going. Adding to
this the actual scanners (i.e. SpamAssassin and AV) memory and CPU usage and it becomes quite
complicated (certainly the debugging info shows that the scanner
harness spends more time running the external scanners than it does
doing things itself [that is to be expected as they do quite a lot of
thinking...]).  <p>As a "rule of thumb" I'd suggest you look at how
many simultaneous SMTP sessions you are willing your box to have going
at any one point in time. Each SMTP session can invoke up to 'n'
different virus scanners (although they run one after the other - not
simultaneously) and I'd estimate that leads to around 10-20Mb of memory
usage per SMTP session.  Thus if your dedicated SMTP host has 1024Mb
RAM + 2048Mb swap - that should mean you can handle - well heaps ;-)
The scanners cause the CPU to be thrashed while they're running, so
I'm making sure for our site that our Qmail servers will only accept up
to 40 incoming SMTP sessions at any one time - that way I know the box
will handle it. As this leads to an increased memory usage, don't
forget Qmail's memory limits  will need to be increased to deal with it (set
via ulimit or softlimit calls with Qmail system startup scripts).
<p>One thing you should test for is what happens if connectivity
between this server and another local SMTP server is down for any
length of time (due to failure/power outage). When the link is
restored, can your server handle the other trying to dump 1,000's of
email msgs onto it at once? You need to use softlimit and tcpserver's
limit options to ensure your box doesn't get killed. Note that this
resource issue isn't "a bug" in  Qmail-Scanner.
The same thing will happen with a pure, untouched Qmail (or any other)
system - it will just happen sooner...
<p>After that scare-mongering I should say that I have tested
Qmail-Scanner under ridiculously low resource conditions - and it reacts as
it should - so at worst your system should start deferring email. Thankfully
DJB's layering of programs is such that this is easy to accomplish :-)
<h2>
Installation</h2>

<ul>
	<li><b>IMPORTANT:</b> Ensure all anti-virus scanners and/or SpamAssassin are installed and operational before attempting to install Qmail-Scanner. Ensure these products are usable by non-root accounts (some people have had problems with permissions on some AV scanners in the past). Remember Qmail-Scanner runs as username <b>qscand</b>, so the AV and SpamAssassin must be able to read files created by it - which basically means they need to run as <b>qscand</b> too</li>
<li>
Unpack <i>Qmail-Scanner</i> and run <b>./configure --help</b>.
This will show you what
<a href="configure-options.php">options</a>
are available to you.</li>

<li>
Run <b>./configure ...</b> [with your options], it will auto-detect
what software is installed on your system, and will generate a script specific
to your system. If you don't see any errors reported, then the build is (probably) successful.</li>

<li>
Run <b>./configure</b> again, this time include "<i>--install</i>" along with the options you chose, this will do the same as the previous line, but will also create the directory structure
required, and install <b>qmail-scanner-queue.pl</b></li>

<li>
If you want to manually install it, see the <a href="manual-install.php">Manual
Installation</a> page.</li>
<li>
	  Before going any further, you can test the installation by running <b>./contrib/test_installation.sh</b>. This will send four emails: one normal, two "infected" with the EICAR test virus, and one obvious SPAM - to what you set to be the Qmail-Scanner "admin" address. Obviously <i>Qmail-Scanner</i> should let one through,catch the viruses, and tag the SPAM as "spammy" (if SpamAssassin is installed of course!). As Qmail-Scanner now defaults to not notifying anyone when a virus is caught, you may have to depend on the logs (e.g. syslog if you used "--log-details=syslog") to see what Qmail-Scanner did.<br> (e.g. <code>tail -10000 /var/log/maillog|egrep " qmail-scanner\[.* Qmail-Scanner_"</code>)</li>

</ul>
At this stage  qmail-smtpd will need to be "told"  that Qmail knows to use <b>qmail-scanner-queue.pl</b>
    instead of <b>qmail-queue</b>. This is done via the tcpserver control files for SMTP. Look to see where tcpserver for qmail-smtpd gets its rules from - it's the file after the "-x" option (well, that's the CDB version actually - find the text file yourself! ;-). Edit that file and tell qmail-smtpd which IP address ranges (corresponds to SMTP client IP addresses) you want Qmail-Scanner to be invoked on - typically all of them.<p>
	  <pre>
#/etc/tcpserver/smtp.rules
#
# No Qmail-Scanner at all for mail from 127.0.0.1
127.:allow,RELAYCLIENT="",RBLSMTPD="",QMAILQUEUE="/var/qmail/bin/qmail-queue"
# Use Qmail-Scanner without SpamAssassin on any mail from the local network
# [it triggers SpamAssassin via the presence of the RELAYCLIENT var]
10.:allow,RELAYCLIENT="",RBLSMTPD="",QMAILQUEUE="/var/qmail/bin/qmail-scanner-queue.pl"
#
# Use Qmail-Scanner with SpamAssassin on any mail from the rest of the world
:allow,QMAILQUEUE="/var/qmail/bin/qmail-scanner-queue.pl"
</pre></p>

<P>
The above example means from now on all SMTP mail will be scanned, but
with different characteristics. Mail from the LAN (10. network) will
be scanned by the supported virus scanners, whereas mail from the
Internet will be scanned for virii AND tagged by SpamAssassin. This
finer control allows you a lot of versatility, e.g. virus scanning
only performed on mail coming from your Exchange server, and not from your Unix mailing-list servers.

<P>

<table>
<tr>
<td BGCOLOR="#F5DEB3">You <em>must</em> increase the amount of memory your system allows qmail-smtpd
to run with, as it it now running the entire perl interpreter PLUS
virus scanners. Typical installs of Qmail have system rc/startup
scripts (e.g. <b>/etc/rc.d/init.d/qmail</b> or <b>/service/smtp/run</b>) that limit the amount of RAM qmail-smtpd can use via ulimit or
softlimit. You must increase that to around 20Mb (totally dependent on your OS and choice of anti-virus scanner). If you don't
qmail-smtpd will crash with a "qq" error on the receipt of the very
first message... The actual amount is dependent on the OS in question as well as the virus scanners being used, so be prepared to experiment a little. Whatever you do, <em>don't</em> just set it to something stupid like 100M "just to be sure". The whole point about limiting RAM usage is so that "unusual" mail messages (e.g. from spammers or hackers) can't cause your system to become unusable by making it run out of RAM. <b><em>THIS IS A FEATURE OF QMAIL - NOT A BUG</em></b>. Also note that as the pattern files for any given non-daemonized AV are upgraded, they catch more and more viruses - and as such need more RAM to load into. So your memory sizes will increase with time. This is a good reason to try to stick to daemonized AV products if you can - as the daemon's memory constraints don't impact Qmail-Scanner (i.e. you can <em>reduce</em> the amount of RAM Qmail-Scanner needs by exclusively using daemonized AV)</td>
</tr>
</table>


<p>To scan all mail sent by local shell users, the <b>QMAILQUEUE</b>
will also need to be defined within <b>/etc/profile</b> or the like so
that when they send mail, it will be affected as well. Similarly, if you are running Webmail apps, that environment variable will need to be available from within the Web server for Qmail-Scanner to scan any emails sent.</p>
<table>
<tr>
<td BGCOLOR="#F5DEB3"><p>Also, think twice before running Qmail-Scanner in front of any mailing-list servers. Do you really think it's a good idea to have 10,000 messages banging away at your anti-virus system at the same time? Either put your mailing-list servers beyond the reach of your Qmail-Scanner servers, or put the mailing-list on the Qmail-Scanner servers themselves - that way each message is only scanned once and the load issues disappear.</p></td>
</tr>
</table>

<p>If "<i>$DEBUG=1</i>" (the default) is set within <b>qmail-scanner-queue.pl</b>, then every transaction
will be logged to
<b>/var/spool/qscan/qmail-queue.log</b> - so you'll
see how it goes. Regardless of debugging, errors (and attachment info if
enabled) should also be recorded in the qmail logs (probably via <i>syslog</i>)
- just look for entries containing the string "<b>X-Qmail-Scanner</b>".
<p>Any SMTP sessions that are dropped (due to network outages/etc)
may lead to files lying around in <b>/var/spool/qscan </b>. Running
<b>/var/qmail/bin/qmail-scanner-queue.pl -z</b> at least once daily will 
ensure such files are deleted when they're
over 30 hours old - make a cronjob to do that (see contrib/ for a logrotate script). Also realize that <b>/var/spool/qscan/qmail-queue.log</b> will grow without bounds. At some stage turn debugging off (<i>$DEBUG=0</i>) and delete the logfile. Personally, I like the logfile, so I run a cronjob that just does "mv -f qmail-queue.log  qmail-queue.log.1" at 3am every morning. That way logs don't grow without bound, but you still end up with the logs from the past two days. The file can be safely deleted at any time if it becomes a disk-hog, but unless "<i>$DEBUG=0</i>" is set, it'll just get re-created the next time a message comes through (again, the contrib/ logrotate script can be used to take care of this).
<P>

Qmail-Scanner contains an internal scanner which allows you to quarantine email
based on attachment filenames and/or email headers. Read the <a href="perlscanner.php">minimal  document</a> on it for details.

<P>
<h2>
Philosophy behind Quarantining...</h2>
When Qmail-Scanner decided to quarantine a message, it moves
      it into  mail folders (maildir format) under <b>/var/spool/qscan/quarantine/</b>. They are split into three different maildir folders based on whether Qmail-Scanner thinks they are a <b>virus</b>, a <b>policy</b> block or high-scoring <b>spam</b> (if you have enabled that option).
This means the message can be read in its pure "adulterated" state (e.g. still containing virii/etc) by maildir
clients like <a href="http://www.mutt.org/">mutt</a> - or via IMAP (if
maildir format supported - you'll have to work that out for yourself).
At worse you can just read it with an editor - it's just a MIME text file...
<p>If you want a good IMAP server that supports maildir natively
- try <a href="http://www.inter7.com/courierimap/">Courier-IMAP</a>.
<p>I made the decision to write it into maildir format for
performance and reliability reasons - and it expressly makes it difficult
for any Windows admin to click on it with their vulnerable Windows mailer
and read it :-) Qmail actually comes with a program called /var/qmail/bin/maildir2mbox
which can do just that... (you could run it from cron to automatically
suck all the new mail messages from <b>/var/spool/qscan/quarantine/*/new/</b>
into a mbox.)
<p>

      <p>Also note that Qmail-Scanner <em>only</em> quarantines. It
      doesn't "clean" messages. </p>




<p>Also this event is logged in <b>/var/spool/qscan/quarantine.log</b>
in a tab-delimited format (for post-processing). See <a   href="http://sourceforge.net/projects/qss/">QSS</a> for an example of one way of generating stats.

<P>
If Qmail-Scanner was configured with the "--log-details" option, then a 
one-line summary of every message processed is recorded either in mailstats.csv or via syslog. e.g:
<P>
	<font size="-2"><pre>
Aug 14 16:22:41 srvname qmail-scanner[30802]: Clear:RC:1(1.2.3.4): 0.030769 11569 root@x.y jdoe@y.z More_Power! <20020814042234.27902.qmail@x.y> 1029298961.30804-0.srvname:10649 
Aug 14 16:23:17 srvname qmail-scanner[30820]: Clear:RC:0(1.2.3.4): 0.033618 2021  root@x.y jdoe@y.z Cron_<root@x.y>_run-parts_/etc/cron.daily <20020814042243.28092.qmail@x.y> 1029298997.30822-0.srvname:895 
Aug 14 16:23:17 srvname qmail-scanner[15885]: Clear:RC:0(1.5.4.3):SA:0(3.0/5.0):CR:PGP(old-signed): 4.66578 5549 fedora-devel-list-bounces@redhat.com Jason.Haar@trimble.co.nz Re:_RFC:_Soname_in_rpm_name <20050128003606.GD16634@neu.nirvana> 1106872589.15888-0.mailsrv2.trimble.co.nz:1046 1106872589.15888-1.mailsrv2.trimble.co.nz:189 1106872589.15888-2.mailsrv2.trimble.co.nz:120 orig-mailsrv2.trimble.co.nz110687258948815885:5549


</pre></font>

      <p>
The format is as follows:
</p>
      <ul>
	<li>[standard syslog stuff]</li>
	<li>qmail-scanner[PID] - thus a single SMTP session with 5 recipients would generate 5 syslog entries - but the PID would be the same - showing you it was the same transaction</li>
	<li>message status: "Clear" or description of quarantine event 
	  <ul>
	    <li>different components of the status are colon-separated, allowing a variety of information to be portrayed in the one record</li>
	    <li>SpamAssassin is recorded as "SA:1" when SA tags the message as Spam, and "SA:0" otherwise</li>
	    <li>The "RC:" bit refers to whether or not the email came from a RELAYCLIENT or not: i.e. "1" says  the message was from a "local" SMTP client and "0" means it was from an Internet one. The IP address of the SMTP client is then shown in brackets (127.0.0.1 is used if there was no IP address). This is extremely useful if (say) you want to trigger a  pager alert if a local SMTP client <em>sends</em> a virus...</li>
	    <li>If you have "--log-crypto" enabled, "CR:OPTION-XXX" will appear in the log record of any message that uses crypto. Options are:
	      <ul>
		<li>"PGP(signed)" or "PGP(encrypted)" for digitally signed or encrypted PGP/MIME emails. There is also "old-signed"/etc to cover the "older" method of doing PGP</li>
		<li>"SMIME(signed)" or "SMIME(encrypted)" for digitally signed or encrypted  S/MIME emails</li>
		<li>"CR:ZIP(encrypted)" for password-protected ZIP files</li>
		<li>"DomKeys" for emails signed with Domain Keys. A bit of a stretch as far as crypto goes - but a signed message is a signed message...</li>
	      </ul>
	    </li>
	  </ul>
	</li>
	<li>time taken (sec) to process the message</li>
	<li>"raw" size of message</li>
	<li>envelope sender (i.e. "mail from")</li>
	<li>envelop recipient (i.e. "rcpt to")</li>
	<li>Subject: header</li>
	<li>Message-ID: header</li>
	<li>space-delimited listing of attachment filenames plus their individual sizes appended to the filename</li>
      </ul>

      <p><b>Note:</b> fields are normalized (i.e. converted from base64/Q-P back to glorious 8bit), space-delimited and limited to 1024 chars when syslog is used (with spaces within fields replaced by underscores), and tab-delimited in mailstats.cvs format
</p>
<h2>
Support</h2>
This software is released under the GPL as found in the <a href="COPYING">COPYING</a>
file enclosed.
<p>This package is housed on <a href="http://sourceforge.net/project/?group_id=6116">SourceForge</a>.
<p>
Any questions, suggestions, etc must be sent to the mailing-list set up to discuss this, subscribe via <a href="http://lists.sourceforge.net/mailman/listinfo/qmail-scanner-general">http://lists.sourceforge.net/mailman/listinfo/qmail-scanner-general</a> ,
or subscribe to the announcements-only list via <a href="http://lists.sourceforge.net/mailman/listinfo/qmail-scanner-announce">http://lists.sourceforge.net/mailman/listinfo/qmail-scanner-announce</a>. 
</p>
<p><font size="-3"><b>Last Updated:</b> <?php echo   date ("r",filemtime($_SERVER[SCRIPT_FILENAME])). " GMT"; ?></font>
<P>
</body>
</html>
